import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner
import time


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_gettingStartedScreenshot(self):
        # Start
        self.driver.save_screenshot("png/gettingStarted_1.png")

        # Add nodes
        self.addNode("Constant")
        self.addNode("InputStream")
        self.reshape()
        self.driver.save_screenshot("png/gettingStarted_2.png")

        # Connect nodes
        self.connect("node_Constant_1", "VALUE",
                     "node_InputStream_1", "INPUT")
        self.driver.save_screenshot("png/gettingStarted_3.png")

        # Add sheet
        name = "LOOP0"
        typ = "iterator"
        self.driver.find_element_by_id("addSheetButton").click()
        form = self.driver.find_element_by_id("addSheetName")
        form.send_keys(name)
        typeform = self.driver.find_element_by_id("addSheetType")
        typeform.send_keys(typ)
        time.sleep(0.5)
        self.driver.save_screenshot("png/gettingStarted_4.png")

        # Add nodes and connect nodes
        form.send_keys(Keys.RETURN)
        self.activateSheet("LOOP0")
        self.addNode("AudioStreamFromWave")
        self.addNode("MultiFFT")
        self.addNode("LocalizeMUSIC")
        self.addNode("SourceTracker")
        self.addNode("DisplayLocalization")
        self.reshape()

        self.connect("node_AudioStreamFromWave_1", "AUDIO",
                     "node_MultiFFT_1", "INPUT")
        self.connect("node_MultiFFT_1", "OUTPUT",
                     "node_LocalizeMUSIC_1", "INPUT")
        self.connect("node_LocalizeMUSIC_1", "OUTPUT",
                     "node_SourceTracker_1", "INPUT")
        self.connect("node_SourceTracker_1", "OUTPUT",
                     "node_DisplayLocalization_1", "SOURCES")
        self.driver.save_screenshot("png/gettingStarted_5.png")

        self.reshape()
        self.driver.save_screenshot("png/gettingStarted_6.png")

        # Hide nodelist
        self.driver.find_element_by_id("minimizeNodelistButton").click()
        self.driver.save_screenshot("png/gettingStarted_7.png")

        # Set parameters
        self.openParam("node_AudioStreamFromWave_1")
        self.driver.save_screenshot("png/gettingStarted_8.png")
        self.closeParam("node_AudioStreamFromWave_1")

        # Add terminal roles
        asfw = "node_AudioStreamFromWave_1"
        disp = "node_DisplayLocalization_1"
        self.addTerminalRole(asfw, "INPUT", "Input")
        self.addTerminalRole(asfw, "NOT_EOF", "Condition")
        self.addTerminalRole(disp, "OUTPUT", "Output")
        self.driver.save_screenshot("png/gettingStarted_9.png")

if __name__ == "__main__":
    unittest.main()
