import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_connect(self):
        # add a sheet
        self.addSheet("LOOP0")

        # add LOOP0 to MAIN
        self.activateSheet("MAIN")
        self.addNode("LOOP0")

        # select LOOP0
        self.activateSheet("LOOP0")
        self.addNode("LocalizeMUSIC")
        self.addNode("SourceTracker")

        self.reshape()

        # connect
        stat = self.driver.find_element_by_id("executeStatus")
        self.connect("node_SourceTracker_1", "INPUT",
                     "node_LocalizeMUSIC_1", "OUTPUT")
        self.assertEqual("", stat.text)

        self.connect("node_SourceTracker_1", "OUTPUT",
                     "node_LocalizeMUSIC_1", "INPUT")
        self.assertIn("Error: Link", stat.text)

if __name__ == "__main__":
    unittest.main()
